--******************************************************************************************************************************
--* Licensed Materials - Property of IBM                                                                                       *
--* (c) Copyright IBM Corp. 2008, 2009 All Rights Reserved.                                                                    *
--*                                                                                                                            *
--*US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp*
--******************************************************************************************************************************

set verify off

WHENEVER OSERROR EXIT
WHENEVER SQLERROR EXIT

DEFINE ORACLE_HOME='&1'
DEFINE ORACLE_SID='&2'
DEFINE CD='&3'
DEFINE sysPassword='&4'
DEFINE systemPassword='&5'
DEFINE sysmanPassword='&6'
DEFINE dbsnmpPassword='&7'
DEFINE ORACLE_BASE='&8'
DEFINE HOST_NAME='&9'
DEFINE ORA_CMD='&10'
DEFINE ORA_VERSION=&11
DEFINE ORA_DBS='&12'

set echo &&ORA_CMD

host &&ORACLE_HOME/bin/orapwd file=&&ORACLE_HOME/&&ORA_DBS/PWD&&ORACLE_SID..ora password="&&sysPassword" force=y>>logs/oraPWD.log

connect "SYS"/"&&sysPassword" as SYSDBA
spool '&&CD/logs/buildDB.log'
startup nomount pfile="&&CD/work_spc/createDB/init&&ORACLE_SID..ora";
set serveroutput on;
variable fname varchar2(255);
declare success boolean;
  begin
       :fname := dbms_backup_restore.deviceAllocate;
    dbms_backup_restore.restoreSetDataFile;
      dbms_backup_restore.restoreDataFileTo(1, '&&ORACLE_BASE/oradata/&&ORACLE_SID/SYSTEM01.DBF', 0, 'SYSTEM');
      dbms_backup_restore.restoreDataFileTo(2, '&&ORACLE_BASE/oradata/&&ORACLE_SID/SYSAUX01.DBF', 0, 'SYSAUX');
      dbms_backup_restore.restoreDataFileTo(3, '&&ORACLE_BASE/oradata/&&ORACLE_SID/UNDOTBS01.DBF', 0, 'UNDOTBS1');
      dbms_backup_restore.restoreDataFileTo(4, '&&ORACLE_BASE/oradata/&&ORACLE_SID/USERS01.DBF', 0, 'USERS');
    dbms_backup_restore.restoreBackupPiece('&&ORACLE_HOME/assistants/dbca/templates/Seed_Database.dfb', success);
    if success then
        dbms_output.put_line('Done restoring');
    else
        dbms_output.put_line('Error Restoring ');
    end if;
    dbms_backup_restore.deviceDeallocate;
  end;
/
Create controlfile reuse set database "&&ORACLE_SID"
MAXINSTANCES 8
MAXLOGHISTORY 1
MAXLOGFILES 16
MAXLOGMEMBERS 3
MAXDATAFILES 100
Datafile 
'&&ORACLE_BASE/oradata/&&ORACLE_SID/SYSTEM01.DBF',
'&&ORACLE_BASE/oradata/&&ORACLE_SID/SYSAUX01.DBF',
'&&ORACLE_BASE/oradata/&&ORACLE_SID/UNDOTBS01.DBF',
'&&ORACLE_BASE/oradata/&&ORACLE_SID/USERS01.DBF'
LOGFILE GROUP 1 ('&&ORACLE_BASE/oradata/&&ORACLE_SID/redo01.log') SIZE 51200K,
GROUP 2 ('&&ORACLE_BASE/oradata/&&ORACLE_SID/redo02.log') SIZE 51200K,
GROUP 3 ('&&ORACLE_BASE/oradata/&&ORACLE_SID/redo03.log') SIZE 51200K RESETLOGS;
exec dbms_backup_restore.zerodbid(0);
WHENEVER SQLERROR CONTINUE
shutdown immediate;
WHENEVER SQLERROR EXIT
startup nomount pfile="&&CD/work_spc/createDB/init&&ORACLE_SID.Temp.ora";
Create controlfile reuse set database "&&ORACLE_SID"
MAXINSTANCES 8
MAXLOGHISTORY 1
MAXLOGFILES 16
MAXLOGMEMBERS 3
MAXDATAFILES 100
Datafile 
'&&ORACLE_BASE/oradata/&&ORACLE_SID/SYSTEM01.DBF',
'&&ORACLE_BASE/oradata/&&ORACLE_SID/SYSAUX01.DBF',
'&&ORACLE_BASE/oradata/&&ORACLE_SID/UNDOTBS01.DBF',
'&&ORACLE_BASE/oradata/&&ORACLE_SID/USERS01.DBF'
LOGFILE GROUP 1 ('&&ORACLE_BASE/oradata/&&ORACLE_SID/redo01.log') SIZE 51200K,
GROUP 2 ('&&ORACLE_BASE/oradata/&&ORACLE_SID/redo02.log') SIZE 51200K,
GROUP 3 ('&&ORACLE_BASE/oradata/&&ORACLE_SID/redo03.log') SIZE 51200K RESETLOGS;
alter system enable restricted session;
alter database "&&ORACLE_SID" open resetlogs;
alter database rename global_name to "&&ORACLE_SID";
ALTER TABLESPACE TEMP ADD TEMPFILE '&&ORACLE_BASE/oradata/&&ORACLE_SID/TEMP01.DBF' SIZE 20480K REUSE AUTOEXTEND ON NEXT 640K MAXSIZE UNLIMITED;
alter database character set INTERNAL_CONVERT AL32UTF8;
alter database national character set INTERNAL_CONVERT UTF8;
alter user sys identified by "&&sysPassword";
alter user system identified by "&&systemPassword";
alter system disable restricted session;
connect "SYS"/"&&sysPassword" as SYSDBA
@&&ORACLE_HOME/rdbms/admin/dbmssml.sql;
execute dbms_datapump_utl.replace_default_dir;
commit;
connect "SYS"/"&&sysPassword" as SYSDBA
alter session set current_schema=ORDSYS;
@&&ORACLE_HOME/ord/im/admin/ordlib.sql;
alter session set current_schema=SYS;
connect "SYS"/"&&sysPassword" as SYSDBA
create spfile='&&ORACLE_HOME/&&ORA_DBS/spfile&&ORACLE_SID..ora' FROM pfile='&&CD/work_spc/createDB/init&&ORACLE_SID..ora';
shutdown immediate;
connect "SYS"/"&&sysPassword" as SYSDBA
startup ;
alter user SYSMAN identified by "&&sysmanPassword" account unlock;
alter user DBSNMP identified by "&&dbsnmpPassword" account unlock;
execute utl_recomp.recomp_serial();
execute dbms_swrf_internal.cleanup_database(cleanup_local => FALSE);
commit;
spool off
exit